﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Collections.ObjectModel;
using System.Runtime.CompilerServices;
using Microsoft.Samples.ServiceHosting.StorageClient;

namespace AzureBlobManager
{
    public partial class Window1 : Window
    {

        private string accountName;
        private string sharedKey;
        private string blobStorageEndPoint;
        
        public Window1()
        {
            InitializeComponent();
            // Set the authentication propertties
            accountName = Properties.Settings.Default.AccountName;
            sharedKey = Properties.Settings.Default.SharedKey;
            blobStorageEndPoint = Properties.Settings.Default.BlobStorageEndPoint;
        }

        private void listBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (listBox1.SelectedIndex != -1)
            {
            string itm = ((BlobContainer)this.listBox1.SelectedValue).ContainerName;
            selectedContainer.Text = itm;
            BlobManager bm = new BlobManager();
            var blobs = bm.ListBlobs(itm, blobStorageEndPoint, accountName, sharedKey);
            this.xamDataGrid1.DataSource = blobs;
            }            
        }

        private void btnDeleteContainer_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            if (MessageBox.Show(@"Are you sure you want to delete " +
                ((BlobContainer)this.listBox1.SelectedValue).ContainerName, 
                "Delete Blob Container", 
                MessageBoxButton.YesNoCancel, 
                MessageBoxImage.Question) == MessageBoxResult.Yes)
            {
                BlobManager bm = new BlobManager();
                string itm = ((BlobContainer)this.listBox1.SelectedValue).ContainerName;
                bm.DeleteContainer(itm, blobStorageEndPoint, accountName, sharedKey);
                btnLoadContainers_Click(null, null);
            }           
        }

        private void btnLoadContainers_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            BlobManager bm = new BlobManager();
            var containers = bm.ListContainers(blobStorageEndPoint, accountName, sharedKey);

            listBox1.DisplayMemberPath = "ContainerName";
            listBox1.ItemsSource = containers.ToList();
        }

        private void btnAddContainer_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            if (this.textBox1.Text != "")
            {
                BlobManager bm = new BlobManager();
                bm.CreateContainer(textBox1.Text.ToLower(), true, blobStorageEndPoint, accountName, sharedKey);
                var containers = bm.ListContainers(blobStorageEndPoint, accountName, sharedKey);

                listBox1.DisplayMemberPath = "ContainerName";
                listBox1.ItemsSource = containers.ToList();
            }
        }

        private void btnAddImage_Click(object sender, RoutedEventArgs e)
        {
            Microsoft.Win32.OpenFileDialog dialog = new Microsoft.Win32.OpenFileDialog();
            {
                dialog.Title = "Select a file";
                dialog.Filter = "All files|*.*";
                dialog.Multiselect = true;

                string container = ((BlobContainer)this.listBox1.SelectedValue).ContainerName;
                dialog.ShowDialog();
                foreach (var f in dialog.FileNames)
                {
                    BlobManager bm = new BlobManager();
                    bm.CreateBlob(container, f, blobStorageEndPoint, accountName, sharedKey);
                }

                BlobManager bm1 = new BlobManager();
                var blobs = bm1.ListBlobs(container, blobStorageEndPoint, accountName, sharedKey);
                this.xamDataGrid1.DataSource = blobs;
            }
        }
    }
}
